Index: main/channel.c
===================================================================
--- main/channel.c	(revision 313184)
+++ main/channel.c	(working copy)
@@ -6241,7 +6241,10 @@
 	ao2_lock(channels);
 
 	/* lock the original channel to determine if the masquerade is require or not */
-	ast_channel_lock(original);
+	if (ast_channel_trylock(original)) {
+		ao2_unlock(channels);
+		return 0; /* I Should not be locked ill be back if i need to or im here already */
+	}
 
 	/* This checks to see if the masquerade has already happened or not.  There is a
 	 * race condition that exists for this function. Since all pvt and channel locks
